"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var querystring_1 = require("querystring");
var FormData = require("form-data");
var got = require("got");
var API_POSTFIX = '/api/v1/';
var ENDPOINTS = {
    postStatus: 'statuses',
    uploadMedia: 'media'
};
function getMastodonEndpoint(server, endpoint) {
    return server + API_POSTFIX + ENDPOINTS[endpoint];
}
function toot(_a) {
    var token = _a.token, status = _a.status, _b = _a.attachments, attachments = _b === void 0 ? [] : _b, _c = _a.server, server = _c === void 0 ? 'https://mastodon.social' : _c;
    return __awaiter(this, void 0, void 0, function () {
        var mediaIds, query, res;
        var _this = this;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0: return [4 /*yield*/, Promise.all(attachments.map(function (path) { return __awaiter(_this, void 0, void 0, function () {
                        var formData, mediaRes;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    formData = new FormData();
                                    formData.append('file', fs.createReadStream(path));
                                    return [4 /*yield*/, got(getMastodonEndpoint(server, 'uploadMedia'), {
                                            body: formData,
                                            headers: { Authorization: "Bearer " + token }
                                        })];
                                case 1:
                                    mediaRes = _a.sent();
                                    return [2 /*return*/, JSON.parse(mediaRes.body).id];
                            }
                        });
                    }); }))
                    // We have to encode the querystring ourselves because of a quirk with the
                    // Mastodon API. From the docs:
                    //
                    // "When an array parameter is mentioned, the Rails convention of specifying
                    // array parameters in query strings is meant. For example, a ruby array like
                    // foo = [1, 2, 3] should be encoded in the params as foo[]=1&foo[]=2&foo[]=3,
                    // with empty square brackets."
                    //
                    // (https://github.com/tootsuite/documentation/blob/master/Using-the-API/API.md#parameter-types)
                ];
                case 1:
                    mediaIds = _d.sent();
                    query = { status: status };
                    if (mediaIds.length > 0) {
                        query['media_ids[]'] = mediaIds;
                    }
                    return [4 /*yield*/, got(getMastodonEndpoint(server, 'postStatus'), {
                            body: querystring_1.stringify(query),
                            headers: {
                                Authorization: "Bearer " + token
                            }
                        })];
                case 2:
                    res = _d.sent();
                    return [2 /*return*/, JSON.parse(res.body)];
            }
        });
    });
}
exports.toot = toot;
//# sourceMappingURL=toot.js.map