"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var util_1 = require("util");
var readFile = util_1.promisify(fs.readFile);
var Twit = require("twit");
function tweet(_a) {
    var consumerKey = _a.consumerKey, consumerSecret = _a.consumerSecret, accessKey = _a.accessKey, accessSecret = _a.accessSecret, status = _a.status, _b = _a.attachments, attachments = _b === void 0 ? [] : _b;
    return __awaiter(this, void 0, void 0, function () {
        var T, mediaIds, statusRequest, updateRes;
        var _this = this;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    T = new Twit({
                        access_token: accessKey,
                        access_token_secret: accessSecret,
                        consumer_key: consumerKey,
                        consumer_secret: consumerSecret
                    });
                    return [4 /*yield*/, Promise.all(attachments.map(function (path) { return __awaiter(_this, void 0, void 0, function () {
                            var base64data, uploadRequest, uploadRes;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, readFile(path, { encoding: 'base64' })];
                                    case 1:
                                        base64data = _a.sent();
                                        uploadRequest = { media_data: base64data };
                                        return [4 /*yield*/, T.post('media/upload', uploadRequest)];
                                    case 2:
                                        uploadRes = _a.sent();
                                        return [2 /*return*/, uploadRes.data.media_id_string];
                                }
                            });
                        }); }))];
                case 1:
                    mediaIds = _c.sent();
                    statusRequest = {
                        status: status,
                        media_ids: mediaIds.join(',')
                    };
                    return [4 /*yield*/, T.post('statuses/update', statusRequest)];
                case 2:
                    updateRes = _c.sent();
                    return [2 /*return*/, updateRes.data];
            }
        });
    });
}
exports.tweet = tweet;
//# sourceMappingURL=tweet.js.map